# Repository for Introductory Information on PyTorch

* author(s): Tom Weber
* date: June 2020


Due to the nature of jupyter notebooks, they don't integrate nicely with git. It is not always straight forward to see what was changed in the commit history. Therefore, I opted to write the notebooks in markdown and then compile them with pandoc into jupyter notebooks.

Documentation for pandoc can be found [here](https://pandoc.org/MANUAL.html#creating-jupyter-notebooks-with-pandoc).

I have included a install script for pandoc on debian-based systems, as they tend to use outdated packages. 

## Dependencies

* **pandoc >2.6**: to compile markdown files into jupyter notebooks
* **python3**: to install the environment and run the jupyter notebooks 
* **latex**: to convert notebooks into pdf

* setting up a python requirement is advised, see Erik's introduction

* **python packages**:	
	- jupyter
	- torch
	- torchvision

## Getting Started

1) Install the virtual environment and jupyter with `make venv`
2) Activate the environment `source .venv/bin/activate`
3) Create the notebooks `make notebooks`
3) Open the first notebook `jupyter notebook notebooks/0_Intro_Jupyter_Cuda.ipynb`

## Make commands

The creation of notebooks and the corresponding html and pdf files is handled by Make.

* `make notebooks`: creates jupyter notebooks in ./notebooks *(needs pandoc)*
* `make pdf`:		creates pdf files of the notebooks in ./pdf *(needs jupyter and latex)*
* `make html`:		creates html files of the notebooks in ./html *(needs jupyter)*
* `make venv`:		create the environment and install jupyter *(needs python3)*
